/* 
 * This Billy-Bass-Serial-Monitor sketch operates the motors in a 2-motor 
 * Bigmouth Billy Bass. It tests the use of the Serial Monitor to control
 * the mouth, head and tail. Entering H and Carriage Return on the
 * computer keyboard turns the head, h returns the head, T bends the tail,
 * t returns the tail, M opens the mouth, and m closes the mouth. CR (the
 * Enter key) must be pressed after each letter.       June 2024
 */

#include <AFMotor.h>            // Attach library.

AF_DCMotor headtail(3);         // Specify which motor ports are used for 
AF_DCMotor mouth(4);            // head/tail motor and mouth motor.

void setup() {
  Serial.begin(9600);           // Set up Serial library at 9600 bps.
  Serial.println("Test to move head, tail and mouth via Serial Monitor."); // Display
  Serial.println("H turns head, h returns head, T bends tail, t returns tail,");// in
  Serial.println("M opens mouth, m closes mouth. PRESS CR AFTER EACH.");// Serial Monitor.
    headtail.setSpeed(255);     // Set speed of motors. Full speed is 255.
    mouth.setSpeed(255);
}
void loop() {
  if (Serial.available()){      // Check if there is input from Serial Monitor.
  char ch = Serial.read();      // Read input from Serial Monitor.
    if (ch == 'H') {
      Serial.println(". Turn the head.");
      headtail.run(RELEASE);    // Turn motor off, in case it was on.
      delay(400);               // Wait while motor moves.
      headtail.run(FORWARD);    // Turn motor on, to turn the head.
      delay(400);               // Wait while motor moves.
    }
    if (ch == 'h') {
      Serial.println(". Return the head.");
      headtail.run(RELEASE);    // Turn motor off.
      delay(400);               // Wait while motor moves.
    }
    if (ch == 'T') {
      Serial.println(". Bend the tail.");
      headtail.run(RELEASE);    // Turn motor off, in case it was on.
      delay(300);               // Wait while motor moves.
      headtail.run(BACKWARD);   // Turn motor on, to bend the tail.
      delay(300);               // Wait while motor moves.
    }
    if (ch == 't') {
      Serial.println(". Return the tail.");
      headtail.run(RELEASE);    // Turn motor off.
      delay(300);               // Wait while motor moves.
    }
    if (ch == 'M') {
      Serial.println(". Open the mouth.");
      mouth.run(RELEASE);       // Turn motor off, in case it was on.
      delay(200);               // Wait while motor moves.
      mouth.run(FORWARD);       // Turn motor on, to open the mouth.
      delay(200);               // Wait while motor moves.
    }
    if (ch == 'm') {
      Serial.println(". Close the mouth.");
      mouth.run(RELEASE);       // Turn motor off.
      delay(200);               // Wait while motor moves.
      mouth.run(BACKWARD);      // Turn motor on, to close the mouth.
      delay(200);               // Wait while motor moves.
      mouth.run(RELEASE);       // Turn motor off. 
    }
  }
}
